import { PropType } from 'vue';
import EditorJS from '@editorjs/editorjs';
import { IWysiswygConfig, WysiwygOutputData } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<WysiwygOutputData | null>;
    };
    toolbarConfigs: {
        required: false;
        type: PropType<IWysiswygConfig>;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    value: {
        required: false;
        type: PropType<WysiwygOutputData | null>;
    };
}, unknown, {
    localIsFocus: boolean;
    localValue: any;
    stateEditor: {
        editor: EditorJS | null;
        isReady: boolean;
    };
}, {
    getAdditionalTools(): Record<string, any>;
    getId(): string;
}, {
    doRenderData(data: WysiwygOutputData | null): void;
    handleChange(): void;
    handleErrorMessage(): any;
    handleToggleFocus(): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_value: any) => true;
    change: (_event: Event) => true;
    input: (_event: Event) => true;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<{
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<WysiwygOutputData | null>;
    };
    toolbarConfigs: {
        required: false;
        type: PropType<IWysiswygConfig>;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    value: {
        required: false;
        type: PropType<WysiwygOutputData | null>;
    };
}>> & {
    onInput?: ((_event: Event) => any) | undefined;
    onChange?: ((_event: Event) => any) | undefined;
    "onUpdate:modelValue"?: ((_value: any) => any) | undefined;
}, {
    required: boolean;
    isError: boolean;
    readOnly: boolean;
}, {}>;
export default _default;
