import "./organization-tree.css";
import { defineComponent as st, openBlock as m, createElementBlock as f, Fragment as E, normalizeClass as X, normalizeStyle as A, withModifiers as p, renderList as D, createElementVNode as T, toDisplayString as q, createCommentVNode as O, resolveComponent as K, normalizeProps as gt, guardReactiveProps as ft, createBlock as G, mergeProps as pt, createVNode as yt, Teleport as St } from "vue";
import $t from "../form-dropdown/form-dropdown.js";
import { _ as rt } from "../../_plugin-vue_export-helper-dad06003.js";
import "../progress-circular/progress-circular.js";
import "../form-input/form-input.js";
import "../../icons-fca12ed8.js";
import "../../helper-4d4ed314.js";
function Ct(t, e) {
  if (t.match(/^[a-z]+:\/\//i))
    return t;
  if (t.match(/^\/\//))
    return window.location.protocol + t;
  if (t.match(/^[a-z]+:/i))
    return t;
  const n = document.implementation.createHTMLDocument(), o = n.createElement("base"), i = n.createElement("a");
  return n.head.appendChild(o), n.body.appendChild(i), e && (o.href = e), i.href = t, i.href;
}
const Pt = (() => {
  let t = 0;
  const e = () => (
    // eslint-disable-next-line no-bitwise
    `0000${(Math.random() * 36 ** 4 << 0).toString(36)}`.slice(-4)
  );
  return () => (t += 1, `u${e()}${t}`);
})();
function I(t) {
  const e = [];
  for (let n = 0, o = t.length; n < o; n++)
    e.push(t[n]);
  return e;
}
function Y(t, e) {
  const o = (t.ownerDocument.defaultView || window).getComputedStyle(t).getPropertyValue(e);
  return o ? parseFloat(o.replace("px", "")) : 0;
}
function wt(t) {
  const e = Y(t, "border-left-width"), n = Y(t, "border-right-width");
  return t.clientWidth + e + n;
}
function vt(t) {
  const e = Y(t, "border-top-width"), n = Y(t, "border-bottom-width");
  return t.clientHeight + e + n;
}
function at(t, e = {}) {
  const n = e.width || wt(t), o = e.height || vt(t);
  return { width: n, height: o };
}
function bt() {
  let t, e;
  try {
    e = process;
  } catch {
  }
  const n = e && e.env ? e.env.devicePixelRatio : null;
  return n && (t = parseInt(n, 10), Number.isNaN(t) && (t = 1)), t || window.devicePixelRatio || 1;
}
const v = 16384;
function kt(t) {
  (t.width > v || t.height > v) && (t.width > v && t.height > v ? t.width > t.height ? (t.height *= v / t.width, t.width = v) : (t.width *= v / t.height, t.height = v) : t.width > v ? (t.height *= v / t.width, t.width = v) : (t.width *= v / t.height, t.height = v));
}
function B(t) {
  return new Promise((e, n) => {
    const o = new Image();
    o.decode = () => e(o), o.onload = () => e(o), o.onerror = n, o.crossOrigin = "anonymous", o.decoding = "async", o.src = t;
  });
}
async function It(t) {
  return Promise.resolve().then(() => new XMLSerializer().serializeToString(t)).then(encodeURIComponent).then((e) => `data:image/svg+xml;charset=utf-8,${e}`);
}
async function Et(t, e, n) {
  const o = "http://www.w3.org/2000/svg", i = document.createElementNS(o, "svg"), r = document.createElementNS(o, "foreignObject");
  return i.setAttribute("width", `${e}`), i.setAttribute("height", `${n}`), i.setAttribute("viewBox", `0 0 ${e} ${n}`), r.setAttribute("width", "100%"), r.setAttribute("height", "100%"), r.setAttribute("x", "0"), r.setAttribute("y", "0"), r.setAttribute("externalResourcesRequired", "true"), i.appendChild(r), r.appendChild(t), It(i);
}
const P = (t, e) => {
  if (t instanceof e)
    return !0;
  const n = Object.getPrototypeOf(t);
  return n === null ? !1 : n.constructor.name === e.name || P(n, e);
};
function Tt(t) {
  const e = t.getPropertyValue("content");
  return `${t.cssText} content: '${e.replace(/'|"/g, "")}';`;
}
function xt(t) {
  return I(t).map((e) => {
    const n = t.getPropertyValue(e), o = t.getPropertyPriority(e);
    return `${e}: ${n}${o ? " !important" : ""};`;
  }).join(" ");
}
function Lt(t, e, n) {
  const o = `.${t}:${e}`, i = n.cssText ? Tt(n) : xt(n);
  return document.createTextNode(`${o}{${i}}`);
}
function Q(t, e, n) {
  const o = window.getComputedStyle(t, n), i = o.getPropertyValue("content");
  if (i === "" || i === "none")
    return;
  const r = Pt();
  try {
    e.className = `${e.className} ${r}`;
  } catch {
    return;
  }
  const s = document.createElement("style");
  s.appendChild(Lt(r, n, o)), e.appendChild(s);
}
function Rt(t, e) {
  Q(t, e, ":before"), Q(t, e, ":after");
}
const _ = "application/font-woff", tt = "image/jpeg", Mt = {
  woff: _,
  woff2: _,
  ttf: "application/font-truetype",
  eot: "application/vnd.ms-fontobject",
  png: "image/png",
  jpg: tt,
  jpeg: tt,
  gif: "image/gif",
  tiff: "image/tiff",
  svg: "image/svg+xml",
  webp: "image/webp"
};
function Dt(t) {
  const e = /\.([^./]*?)$/g.exec(t);
  return e ? e[1] : "";
}
function N(t) {
  const e = Dt(t).toLowerCase();
  return Mt[e] || "";
}
function Ot(t) {
  return t.split(/,/)[1];
}
function Z(t) {
  return t.search(/^(data:)/) !== -1;
}
function ct(t, e) {
  return `data:${e};base64,${t}`;
}
async function lt(t, e, n) {
  const o = await fetch(t, e);
  if (o.status === 404)
    throw new Error(`Resource "${o.url}" not found`);
  const i = await o.blob();
  return new Promise((r, s) => {
    const a = new FileReader();
    a.onerror = s, a.onloadend = () => {
      try {
        r(n({ res: o, result: a.result }));
      } catch (c) {
        s(c);
      }
    }, a.readAsDataURL(i);
  });
}
const j = {};
function Xt(t, e, n) {
  let o = t.replace(/\?.*/, "");
  return n && (o = t), /ttf|otf|eot|woff2?/i.test(o) && (o = o.replace(/.*\//, "")), e ? `[${e}]${o}` : o;
}
async function J(t, e, n) {
  const o = Xt(t, e, n.includeQueryParams);
  if (j[o] != null)
    return j[o];
  n.cacheBust && (t += (/\?/.test(t) ? "&" : "?") + (/* @__PURE__ */ new Date()).getTime());
  let i;
  try {
    const r = await lt(t, n.fetchRequestInit, ({ res: s, result: a }) => (e || (e = s.headers.get("Content-Type") || ""), Ot(a)));
    i = ct(r, e);
  } catch (r) {
    i = n.imagePlaceholder || "";
    let s = `Failed to fetch resource: ${t}`;
    r && (s = typeof r == "string" ? r : r.message), s && console.warn(s);
  }
  return j[o] = i, i;
}
async function At(t) {
  const e = t.toDataURL();
  return e === "data:," ? t.cloneNode(!1) : B(e);
}
async function Ft(t, e) {
  if (t.currentSrc) {
    const r = document.createElement("canvas"), s = r.getContext("2d");
    r.width = t.clientWidth, r.height = t.clientHeight, s == null || s.drawImage(t, 0, 0, r.width, r.height);
    const a = r.toDataURL();
    return B(a);
  }
  const n = t.poster, o = N(n), i = await J(n, o, e);
  return B(i);
}
async function Yt(t) {
  var e;
  try {
    if (!((e = t == null ? void 0 : t.contentDocument) === null || e === void 0) && e.body)
      return await U(t.contentDocument.body, {}, !0);
  } catch {
  }
  return t.cloneNode(!1);
}
async function Bt(t, e) {
  return P(t, HTMLCanvasElement) ? At(t) : P(t, HTMLVideoElement) ? Ft(t, e) : P(t, HTMLIFrameElement) ? Yt(t) : t.cloneNode(!1);
}
const Ht = (t) => t.tagName != null && t.tagName.toUpperCase() === "SLOT";
async function Ut(t, e, n) {
  var o, i;
  let r = [];
  return Ht(t) && t.assignedNodes ? r = I(t.assignedNodes()) : P(t, HTMLIFrameElement) && (!((o = t.contentDocument) === null || o === void 0) && o.body) ? r = I(t.contentDocument.body.childNodes) : r = I(((i = t.shadowRoot) !== null && i !== void 0 ? i : t).childNodes), r.length === 0 || P(t, HTMLVideoElement) || await r.reduce((s, a) => s.then(() => U(a, n)).then((c) => {
    c && e.appendChild(c);
  }), Promise.resolve()), e;
}
function Wt(t, e) {
  const n = e.style;
  if (!n)
    return;
  const o = window.getComputedStyle(t);
  o.cssText ? (n.cssText = o.cssText, n.transformOrigin = o.transformOrigin) : I(o).forEach((i) => {
    let r = o.getPropertyValue(i);
    i === "font-size" && r.endsWith("px") && (r = `${Math.floor(parseFloat(r.substring(0, r.length - 2))) - 0.1}px`), P(t, HTMLIFrameElement) && i === "display" && r === "inline" && (r = "block"), i === "d" && e.getAttribute("d") && (r = `path(${e.getAttribute("d")})`), n.setProperty(i, r, o.getPropertyPriority(i));
  });
}
function zt(t, e) {
  P(t, HTMLTextAreaElement) && (e.innerHTML = t.value), P(t, HTMLInputElement) && e.setAttribute("value", t.value);
}
function Vt(t, e) {
  if (P(t, HTMLSelectElement)) {
    const n = e, o = Array.from(n.children).find((i) => t.value === i.getAttribute("value"));
    o && o.setAttribute("selected", "");
  }
}
function qt(t, e) {
  return P(e, Element) && (Wt(t, e), Rt(t, e), zt(t, e), Vt(t, e)), e;
}
async function jt(t, e) {
  const n = t.querySelectorAll ? t.querySelectorAll("use") : [];
  if (n.length === 0)
    return t;
  const o = {};
  for (let r = 0; r < n.length; r++) {
    const a = n[r].getAttribute("xlink:href");
    if (a) {
      const c = t.querySelector(a), l = document.querySelector(a);
      !c && l && !o[a] && (o[a] = await U(l, e, !0));
    }
  }
  const i = Object.values(o);
  if (i.length) {
    const r = "http://www.w3.org/1999/xhtml", s = document.createElementNS(r, "svg");
    s.setAttribute("xmlns", r), s.style.position = "absolute", s.style.width = "0", s.style.height = "0", s.style.overflow = "hidden", s.style.display = "none";
    const a = document.createElementNS(r, "defs");
    s.appendChild(a);
    for (let c = 0; c < i.length; c++)
      a.appendChild(i[c]);
    t.appendChild(s);
  }
  return t;
}
async function U(t, e, n) {
  return !n && e.filter && !e.filter(t) ? null : Promise.resolve(t).then((o) => Bt(o, e)).then((o) => Ut(t, o, e)).then((o) => qt(t, o)).then((o) => jt(o, e));
}
const ht = /url\((['"]?)([^'"]+?)\1\)/g, Zt = /url\([^)]+\)\s*format\((["']?)([^"']+)\1\)/g, Nt = /src:\s*(?:url\([^)]+\)\s*format\([^)]+\)[,;]\s*)+/g;
function Jt(t) {
  const e = t.replace(/([.*+?^${}()|\[\]\/\\])/g, "\\$1");
  return new RegExp(`(url\\(['"]?)(${e})(['"]?\\))`, "g");
}
function Kt(t) {
  const e = [];
  return t.replace(ht, (n, o, i) => (e.push(i), n)), e.filter((n) => !Z(n));
}
async function Gt(t, e, n, o, i) {
  try {
    const r = n ? Ct(e, n) : e, s = N(e);
    let a;
    if (i) {
      const c = await i(r);
      a = ct(c, s);
    } else
      a = await J(r, s, o);
    return t.replace(Jt(e), `$1${a}$3`);
  } catch {
  }
  return t;
}
function Qt(t, { preferredFontFormat: e }) {
  return e ? t.replace(Nt, (n) => {
    for (; ; ) {
      const [o, , i] = Zt.exec(n) || [];
      if (!i)
        return "";
      if (i === e)
        return `src: ${o};`;
    }
  }) : t;
}
function dt(t) {
  return t.search(ht) !== -1;
}
async function ut(t, e, n) {
  if (!dt(t))
    return t;
  const o = Qt(t, n);
  return Kt(o).reduce((r, s) => r.then((a) => Gt(a, s, e, n)), Promise.resolve(o));
}
async function F(t, e, n) {
  var o;
  const i = (o = e.style) === null || o === void 0 ? void 0 : o.getPropertyValue(t);
  if (i) {
    const r = await ut(i, null, n);
    return e.style.setProperty(t, r, e.style.getPropertyPriority(t)), !0;
  }
  return !1;
}
async function _t(t, e) {
  await F("background", t, e) || await F("background-image", t, e), await F("mask", t, e) || await F("mask-image", t, e);
}
async function te(t, e) {
  const n = P(t, HTMLImageElement);
  if (!(n && !Z(t.src)) && !(P(t, SVGImageElement) && !Z(t.href.baseVal)))
    return;
  const o = n ? t.src : t.href.baseVal, i = await J(o, N(o), e);
  await new Promise((r, s) => {
    t.onload = r, t.onerror = s;
    const a = t;
    a.decode && (a.decode = r), a.loading === "lazy" && (a.loading = "eager"), n ? (t.srcset = "", t.src = i) : t.href.baseVal = i;
  });
}
async function ee(t, e) {
  const o = I(t.childNodes).map((i) => mt(i, e));
  await Promise.all(o).then(() => t);
}
async function mt(t, e) {
  P(t, Element) && (await _t(t, e), await te(t, e), await ee(t, e));
}
function ne(t, e) {
  const { style: n } = t;
  e.backgroundColor && (n.backgroundColor = e.backgroundColor), e.width && (n.width = `${e.width}px`), e.height && (n.height = `${e.height}px`);
  const o = e.style;
  return o != null && Object.keys(o).forEach((i) => {
    n[i] = o[i];
  }), t;
}
const et = {};
async function nt(t) {
  let e = et[t];
  if (e != null)
    return e;
  const o = await (await fetch(t)).text();
  return e = { url: t, cssText: o }, et[t] = e, e;
}
async function ot(t, e) {
  let n = t.cssText;
  const o = /url\(["']?([^"')]+)["']?\)/g, r = (n.match(/url\([^)]+\)/g) || []).map(async (s) => {
    let a = s.replace(o, "$1");
    return a.startsWith("https://") || (a = new URL(a, t.url).href), lt(a, e.fetchRequestInit, ({ result: c }) => (n = n.replace(s, `url(${c})`), [s, c]));
  });
  return Promise.all(r).then(() => n);
}
function it(t) {
  if (t == null)
    return [];
  const e = [], n = /(\/\*[\s\S]*?\*\/)/gi;
  let o = t.replace(n, "");
  const i = new RegExp("((@.*?keyframes [\\s\\S]*?){([\\s\\S]*?}\\s*?)})", "gi");
  for (; ; ) {
    const c = i.exec(o);
    if (c === null)
      break;
    e.push(c[0]);
  }
  o = o.replace(i, "");
  const r = /@import[\s\S]*?url\([^)]*\)[\s\S]*?;/gi, s = "((\\s*?(?:\\/\\*[\\s\\S]*?\\*\\/)?\\s*?@media[\\s\\S]*?){([\\s\\S]*?)}\\s*?})|(([\\s\\S]*?){([\\s\\S]*?)})", a = new RegExp(s, "gi");
  for (; ; ) {
    let c = r.exec(o);
    if (c === null) {
      if (c = a.exec(o), c === null)
        break;
      r.lastIndex = a.lastIndex;
    } else
      a.lastIndex = r.lastIndex;
    e.push(c[0]);
  }
  return e;
}
async function oe(t, e) {
  const n = [], o = [];
  return t.forEach((i) => {
    if ("cssRules" in i)
      try {
        I(i.cssRules || []).forEach((r, s) => {
          if (r.type === CSSRule.IMPORT_RULE) {
            let a = s + 1;
            const c = r.href, l = nt(c).then((h) => ot(h, e)).then((h) => it(h).forEach((u) => {
              try {
                i.insertRule(u, u.startsWith("@import") ? a += 1 : i.cssRules.length);
              } catch (g) {
                console.error("Error inserting rule from remote css", {
                  rule: u,
                  error: g
                });
              }
            })).catch((h) => {
              console.error("Error loading remote css", h.toString());
            });
            o.push(l);
          }
        });
      } catch (r) {
        const s = t.find((a) => a.href == null) || document.styleSheets[0];
        i.href != null && o.push(nt(i.href).then((a) => ot(a, e)).then((a) => it(a).forEach((c) => {
          s.insertRule(c, i.cssRules.length);
        })).catch((a) => {
          console.error("Error loading remote stylesheet", a);
        })), console.error("Error inlining remote css file", r);
      }
  }), Promise.all(o).then(() => (t.forEach((i) => {
    if ("cssRules" in i)
      try {
        I(i.cssRules || []).forEach((r) => {
          n.push(r);
        });
      } catch (r) {
        console.error(`Error while reading CSS rules from ${i.href}`, r);
      }
  }), n));
}
function ie(t) {
  return t.filter((e) => e.type === CSSRule.FONT_FACE_RULE).filter((e) => dt(e.style.getPropertyValue("src")));
}
async function se(t, e) {
  if (t.ownerDocument == null)
    throw new Error("Provided element is not within a Document");
  const n = I(t.ownerDocument.styleSheets), o = await oe(n, e);
  return ie(o);
}
async function re(t, e) {
  const n = await se(t, e);
  return (await Promise.all(n.map((i) => {
    const r = i.parentStyleSheet ? i.parentStyleSheet.href : null;
    return ut(i.cssText, r, e);
  }))).join(`
`);
}
async function ae(t, e) {
  const n = e.fontEmbedCSS != null ? e.fontEmbedCSS : e.skipFonts ? null : await re(t, e);
  if (n) {
    const o = document.createElement("style"), i = document.createTextNode(n);
    o.appendChild(i), t.firstChild ? t.insertBefore(o, t.firstChild) : t.appendChild(o);
  }
}
async function ce(t, e = {}) {
  const { width: n, height: o } = at(t, e), i = await U(t, e, !0);
  return await ae(i, e), await mt(i, e), ne(i, e), await Et(i, n, o);
}
async function le(t, e = {}) {
  const { width: n, height: o } = at(t, e), i = await ce(t, e), r = await B(i), s = document.createElement("canvas"), a = s.getContext("2d"), c = e.pixelRatio || bt(), l = e.canvasWidth || n, h = e.canvasHeight || o;
  return s.width = l * c, s.height = h * c, e.skipAutoScale || kt(s), s.style.width = `${l}`, s.style.height = `${h}`, e.backgroundColor && (a.fillStyle = e.backgroundColor, a.fillRect(0, 0, s.width, s.height)), a.drawImage(r, 0, 0, s.width, s.height), s;
}
async function he(t, e = {}) {
  return (await le(t, e)).toDataURL();
}
const H = (t, e) => t < 1 ? {
  x: e.x + 5,
  y: e.y
} : t >= 1 && t <= 3 ? {
  x: e.x,
  y: e.y + 5
} : t >= 4 && t <= 6 ? {
  x: e.x,
  y: e.y - 5
} : {
  x: e.x - 5,
  y: e.y
}, de = (t, e) => [...t].sort(
  (i, r) => {
    const s = Math.sqrt(
      (i.x - e.x) * (i.x - e.x) + (i.y - e.y) * (i.y - e.y)
    ), a = Math.sqrt(
      (r.x - e.x) * (r.x - e.x) + (r.y - e.y) * (r.y - e.y)
    );
    return s - a;
  }
).reverse(), ue = (t, e, n) => {
  const {
    canvasHeight: o,
    canvasWidth: i,
    x: r,
    y: s
  } = n, { from: a, points: c, to: l } = t, h = document.querySelector(
    `#org-${e} #org-${e}-item-${a.item}-io-${a.io}`
  ), u = document.querySelector(
    `#org-${e} #org-${e}-item-${l.item}-io-${l.io}`
  );
  if (h && u) {
    const {
      height: g,
      width: d,
      x: S,
      y
    } = h.getBoundingClientRect().toJSON(), {
      height: $,
      width: C,
      x,
      y: L
    } = u.getBoundingClientRect().toJSON(), b = d / 2 + (S - r) * i, k = g / 2 + (y - s) * o, w = C / 2 + (x - r) * i, W = $ / 2 + (L - s) * o, R = {
      ...H(a.io, {
        x: Math.round(b / 5) * 5,
        y: Math.round(k / 5) * 5
      })
    }, M = {
      ...H(l.io, {
        x: Math.round(w / 5) * 5,
        y: Math.round(W / 5) * 5
      })
    };
    if (c != null && c.length) {
      const z = c.map((Ye, V) => V === c.length - 1 ? `L ${M.x} ${M.y}` : `L ${c[V + 1].x} ${c[V + 1].y}`).join(" ");
      return `M ${R.x} ${R.y} L ${c[0].x} ${c[0].y} ${z}`;
    }
    return `M ${R.x} ${R.y} L ${M.x} ${M.y}`;
  }
}, me = (t, e, n, o, i) => {
  const {
    canvasHeight: r,
    canvasWidth: s,
    x: a,
    y: c
  } = i, l = e.from.item === t, { from: h, to: u } = e, g = document.querySelector(
    `#org-${o} #org-${o}-item-${h.item}-io-${h.io}`
  ), d = document.querySelector(
    `#org-${o} #org-${o}-item-${u.item}-io-${u.io}`
  );
  if (!l && d && n && n[0]) {
    const {
      height: S,
      width: y,
      x: $,
      y: C
    } = d.getBoundingClientRect().toJSON(), x = y / 2 + ($ - a) * s, L = S / 2 + (C - c) * r, b = {
      ...H(u.io, {
        x: Math.round(x / 5) * 5,
        y: Math.round(L / 5) * 5
      })
    }, k = n[0].getAttribute("d");
    if (k) {
      const w = k.split(" ");
      return w[w.length - 2] = String(b.x), w[w.length - 1] = String(b.y), w.join(" ");
    }
  } else if (g && n && n[0]) {
    const {
      height: S,
      width: y,
      x: $,
      y: C
    } = g.getBoundingClientRect().toJSON(), x = y / 2 + ($ - a) * s, L = S / 2 + (C - c) * r, b = {
      ...H(h.io, {
        x: Math.round(x / 5) * 5,
        y: Math.round(L / 5) * 5
      })
    }, k = n[0].getAttribute("d");
    if (k) {
      const w = k.split(" ");
      return w[1] = String(b.x), w[2] = String(b.y), w.join(" ");
    }
  }
}, ge = (t, e) => {
  if (e) {
    const n = e[0].getAttribute("d");
    if (n) {
      const o = n.split(" "), i = `L ${o[o.length - 2]} ${o[o.length - 1]}`, r = `M ${o[1]} ${o[2]}`;
      if (t != null && t.length) {
        const s = t.map((c) => `L ${c.x} ${c.y}`).join(" ");
        return `${r} ${s} ${i}`;
      }
      return `${r} ${i}`;
    }
  }
}, fe = st({
  emits: {
    changePoint: (t, e) => !0,
    clickItem: (t, e) => !0,
    dragItem: (t) => !0,
    dragConnection: (t, e) => !0,
    dragPoint: (t, e) => !0,
    selectConnection: (t) => !0
  },
  props: {
    canvasState: {
      required: !0,
      type: Object
    },
    connectorState: {
      required: !0,
      type: Object
    },
    isDragged: {
      required: !1,
      type: Boolean
    },
    isSelected: {
      required: !1,
      type: Boolean
    },
    isEditable: {
      required: !1,
      type: Boolean
    },
    item: {
      required: !0,
      type: Object
    },
    selectedConnection: {
      required: !1,
      type: Object
    }
  },
  name: "sb-organization-tree-item",
  data() {
    return {
      connectionsPath: {}
    };
  },
  computed: {
    getItemPosition() {
      return {
        left: this.item.coordinates.x ? `${this.item.coordinates.x}px` : 0,
        top: this.item.coordinates.y ? `${this.item.coordinates.y}px` : 0
      };
    },
    isConnecting() {
      return this.connectorState.from ? this.connectorState.from.split("-io-")[0] === this.$.vnode.key : !1;
    }
  },
  methods: {
    getConnectionPath(t) {
      if (this.canvasState.elem) {
        const e = String(this.$.vnode.key).split("-item-")[0].replace("org-", ""), n = this.canvasState.elem.getBoundingClientRect().toJSON(), o = n.height || 0, i = n.width || 0, r = i / (i * this.canvasState.zoom) || 0, s = o / (o * this.canvasState.zoom) || 0;
        return ue(t, e, {
          canvasHeight: s,
          canvasWidth: r,
          x: n.x,
          y: n.y
        });
      }
    },
    getConnectionPathString(t) {
      return this.connectionsPath[`${String(this.$.vnode.key)}-connection-${t.from.item}-${t.from.io}-${t.to.item}-${t.to.io}`];
    },
    getCoordinatesMove(t) {
      return t.type === "touchstart" ? {
        x: t.touches[0].clientX,
        y: t.touches[0].clientY
      } : {
        x: t.clientX,
        y: t.clientY
      };
    },
    handleCircleDoubleClick(t, e) {
      var n;
      if (this.isEditable) {
        const o = [
          ...this.item.connections || []
        ], i = [
          ...((n = o[t]) == null ? void 0 : n.points) || []
        ];
        i.splice(e, 1), o[t] = {
          ...o[t],
          points: [...i]
        };
        const r = Number(
          String(this.$.vnode.key).split("-item-")[1]
        );
        this.$emit(
          "changePoint",
          {
            ...this.item,
            connections: [...o]
          },
          r
        );
      }
    },
    handleClickIO(t, e) {
      const n = t.target;
      if (n && this.isEditable) {
        const o = n.getBoundingClientRect();
        this.$emit(
          "dragConnection",
          `${String(this.$.vnode.key)}-io-${e}`,
          o
        );
      }
    },
    handleClickPoint(t, e, n) {
      const o = t.target;
      if (o && this.isEditable) {
        const i = o.getBoundingClientRect();
        this.$emit(
          "dragPoint",
          {
            connection: e,
            item: Number(
              String(this.$.vnode.key).split("-item-")[1]
            ),
            point: n
          },
          i
        );
      }
    },
    handleConnectionClick(t, e) {
      if (this.isEditable && t.target) {
        const n = {
          ...this.item.connections[e] || {}
        };
        this.$emit("selectConnection", {
          from: n.from,
          key: `${String(this.$.vnode.key)}-connection-${e}`,
          to: n.to,
          type: n.type
        });
      }
    },
    handleConnectionDoubleClick(t, e) {
      const n = [
        ...this.item.connections || []
      ], { elem: o, zoom: i } = this.canvasState;
      if (o && this.isEditable) {
        const { height: r, width: s, x: a, y: c } = o.getBoundingClientRect().toJSON(), l = t.clientX, h = t.clientY, u = l * (s / (s * i)) - a * (s / (s * i)), g = h * (r / (r * i)) - c * (r / (r * i)), d = String(this.$.vnode.key).split(
          "-item-"
        )[0], S = document.getElementById(
          `${d}-item-${n[e].to.item}-io-${n[e].to.io}`
        );
        if (S && this.canvasState.elem) {
          const {
            height: y,
            width: $,
            x: C,
            y: x
          } = S.getBoundingClientRect().toJSON(), {
            height: L,
            width: b,
            x: k,
            y: w
          } = this.canvasState.elem.getBoundingClientRect().toJSON(), W = $ / 2 + (C - k) * b, R = y / 2 + (x - w) * L, M = [
            ...de(
              [
                ...n[e].points || [],
                {
                  x: u,
                  y: g
                }
              ],
              {
                x: W,
                y: R
              }
            )
          ];
          n[e] = {
            ...n[e],
            points: [...M]
          };
          const z = Number(
            String(this.$.vnode.key).split("-item-")[1]
          );
          this.$emit(
            "changePoint",
            {
              ...this.item,
              connections: [...n]
            },
            z
          );
        }
      }
    },
    handleInitConnections() {
      this.item.connections && (this.connectionsPath = {}, this.item.connections.forEach((t) => {
        const e = this.getConnectionPath(t);
        this.connectionsPath[`${String(this.$.vnode.key)}-connection-${t.from.item}-${t.from.io}-${t.to.item}-${t.to.io}`] = e;
      }));
    },
    handleItemClick(t) {
      if (!t.target.classList.contains("io"))
        if (this.isEditable) {
          const n = this.getCoordinatesMove(t);
          this.$emit("dragItem", {
            coordinates: n,
            elem: this.$el.nextSibling,
            key: this.$.vnode.key
          });
        } else {
          const n = Number(
            String(this.$.vnode.key).split("-item-")[1]
          );
          this.$emit("clickItem", this.item, n);
        }
    },
    isConnectionSelected(t) {
      return this.selectedConnection ? `${String(this.$.vnode.key)}-connection-${t}` === this.selectedConnection.key : !1;
    }
  },
  mounted() {
    this.handleInitConnections();
  },
  watch: {
    "item.connections": {
      deep: !0,
      handler() {
        this.$nextTick(() => this.handleInitConnections());
      }
    }
  }
}), pe = ["id"], ye = ["id", "onMousedown", "onTouchstart"], Se = { class: "text" }, $e = ["id"], Ce = ["id", "onMousedown", "onTouchstart"], Pe = { class: "data-wrapper" }, we = { class: "name" }, ve = { class: "position" }, be = ["innerHTML"], ke = ["id"], Ie = ["d", "onClick", "onDblclick"], Ee = ["cx", "cy", "onDblclick", "onMousedown", "onTouchstart"];
function Te(t, e, n, o, i, r) {
  return m(), f(E, null, [
    t.item.department ? (m(), f("div", {
      key: 0,
      class: X(["department", {
        connecting: t.isConnecting,
        draggable: t.isEditable,
        dragged: t.isDragged,
        selected: t.isSelected
      }]),
      id: String(t.$.vnode.key),
      style: A(t.getItemPosition),
      onMousedown: e[0] || (e[0] = p((...s) => t.handleItemClick && t.handleItemClick(...s), ["stop"])),
      onTouchstart: e[1] || (e[1] = p((...s) => t.handleItemClick && t.handleItemClick(...s), ["stop"]))
    }, [
      (m(!0), f(E, null, D([...Array(8).keys()], (s) => (m(), f("span", {
        class: "io",
        id: `${String(t.$.vnode.key)}-io-${s}`,
        key: `io-${s}`,
        onMousedown: p((a) => t.handleClickIO(a, s), ["stop"]),
        onTouchstart: p((a) => t.handleClickIO(a, s), ["stop"])
      }, null, 40, ye))), 128)),
      T("div", Se, q(t.item.department), 1)
    ], 46, pe)) : (m(), f("div", {
      key: 1,
      class: X(["card", {
        connecting: t.isConnecting,
        draggable: t.isEditable,
        dragged: t.isDragged,
        selected: t.isSelected
      }]),
      id: String(t.$.vnode.key),
      style: A(t.getItemPosition),
      onMousedown: e[2] || (e[2] = p((...s) => t.handleItemClick && t.handleItemClick(...s), ["stop"])),
      onTouchstart: e[3] || (e[3] = p((...s) => t.handleItemClick && t.handleItemClick(...s), ["stop"]))
    }, [
      (m(!0), f(E, null, D([...Array(8).keys()], (s) => (m(), f("span", {
        class: "io",
        id: `${String(t.$.vnode.key)}-io-${s}`,
        key: `io-${s}`,
        onMousedown: p((a) => t.handleClickIO(a, s), ["stop"]),
        onTouchstart: p((a) => t.handleClickIO(a, s), ["stop"])
      }, null, 40, Ce))), 128)),
      t.item.photo ? (m(), f("div", {
        key: 0,
        class: "item-photo",
        style: A({
          backgroundImage: `url(${t.item.photo})`
        })
      }, null, 4)) : O("", !0),
      T("div", Pe, [
        t.item.renderInfo ? (m(), f("div", {
          key: 1,
          innerHTML: t.item.renderInfo(t.item)
        }, null, 8, be)) : (m(), f(E, { key: 0 }, [
          T("p", we, q(t.item.name || "-"), 1),
          T("p", ve, q(t.item.position || "-"), 1)
        ], 64))
      ])
    ], 46, $e)),
    (m(!0), f(E, null, D(t.item.connections || [], (s, a) => (m(), f("svg", {
      class: X(["connection", [
        s.type || "solid",
        t.isConnectionSelected(a) && "selected",
        t.isEditable && "editable"
      ]]),
      xmlns: "http://www.w3.org/2000/svg",
      id: `${String(t.$.vnode.key)}-connection-${a}`,
      key: `${String(t.$.vnode.key)}-connection-${a}`
    }, [
      T("path", {
        d: t.getConnectionPathString(s),
        onClick: p((c) => t.handleConnectionClick(c, a), ["stop"]),
        onDblclick: p((c) => t.handleConnectionDoubleClick(c, a), ["stop"])
      }, null, 40, Ie),
      (m(!0), f(E, null, D(s.points || [], (c, l) => (m(), f("circle", {
        class: "circle",
        r: "6",
        cx: c.x,
        cy: c.y,
        key: `${String(
          t.$.vnode.key
        )}-connection-${a}-circle-${l}`,
        onDblclick: p((h) => t.handleCircleDoubleClick(a, l), ["stop"]),
        onMousedown: p((h) => t.handleClickPoint(h, a, l), ["stop"]),
        onTouchstart: p((h) => t.handleClickPoint(h, a, l), ["stop"])
      }, null, 40, Ee))), 128))
    ], 10, ke))), 128))
  ], 64);
}
const xe = /* @__PURE__ */ rt(fe, [["render", Te]]), Le = st({
  emits: {
    change: (t) => !0,
    clickItem: (t, e) => !0
  },
  props: {
    isEditable: {
      required: !1,
      type: Boolean
    },
    list: {
      required: !0,
      type: Object
    }
  },
  name: "sb-organization-tree",
  components: {
    "sb-dropdown": $t,
    "sb-org-tree-item": xe
  },
  data() {
    return {
      canvasState: {
        coordinates: {
          x: 0,
          y: 0
        },
        elem: null,
        lastZoom: 1,
        zoom: 1
      },
      canvasStyle: {},
      connectorState: {
        from: null,
        fromRect: null,
        toCoordinates: null
      },
      draggedItem: null,
      exportAreaStyle: {},
      isExporting: !1,
      isItemMoved: !1,
      lineType: [
        {
          label: "Solid",
          value: "solid"
        },
        {
          label: "Dashed",
          value: "dashed"
        },
        {
          label: "Dotted",
          value: "dotted"
        }
      ],
      localList: [],
      mouseState: {
        mouse: {
          x: 0,
          y: 0
        },
        position: {
          x: 0,
          y: 0
        },
        positionStart: {
          x: 0,
          y: 0
        }
      },
      parentPointerState: {
        events: [],
        prevDiff: -1
      },
      parentState: {
        isDrag: !1,
        position: {
          x: 0,
          y: 0
        }
      },
      pointState: {
        fromRect: null,
        target: null,
        toCoordinates: null
      },
      selectedConnection: null,
      selectedItem: null,
      selectedLineType: "solid"
    };
  },
  computed: {
    getMinMaxXY() {
      const e = [...[...this.localList].flatMap(
        (d) => d.connections ? [...d.connections] : []
      )].flatMap(
        (d) => d.points ? [...d.points] : []
      ), n = [...this.localList].map(
        (d) => d.coordinates
      ), o = [...n].map(
        (d) => d.x
      ), i = [...n].map(
        (d) => d.x + 220
      ), r = [...n].map(
        (d) => d.y
      ), s = [...n].map(
        (d) => d.y + 100
      ), a = [
        ...[...e].map((d) => d.x),
        ...o,
        ...i
      ], c = [
        ...[...e].map((d) => d.y),
        ...r,
        ...s
      ], l = Math.max.apply(null, a), h = Math.min.apply(null, a), u = Math.max.apply(null, c), g = Math.min.apply(null, c);
      return {
        maxX: l,
        minX: h,
        maxY: u,
        minY: g
      };
    }
  },
  methods: {
    async doExport() {
      this.selectedConnection = null, this.isExporting = !0, await new Promise(
        (a) => setTimeout(() => {
          a(!0);
        }, 200)
      );
      const { maxX: t, minX: e, maxY: n, minY: o } = this.getMinMaxXY, i = Math.abs(o) + n, r = Math.abs(e) + t, s = this.canvasState.elem;
      if (this.exportAreaStyle = {
        height: `${i + 40}px`,
        width: `${r + 40}px`
      }, s) {
        const a = s.cloneNode(
          !0
        );
        a.classList.remove("connection-selected"), a.style.transform = "none", a.style.background = "transparent", a.style.height = `${i}px`, a.style.position = "relative", a.style.width = `${r}px`;
        const c = document.getElementById(
          `org-${this.$.uid}-export-area`
        );
        if (c) {
          c.appendChild(a);
          const l = await he(
            c,
            {
              style: {
                opacity: "1"
              }
            }
          ).catch(() => null);
          return a.remove(), this.isExporting = !1, l;
        }
      }
      return null;
    },
    doParentZoom(t) {
      this.canvasState.zoom += t, this.$nextTick(() => this.doParentZoomRefresh());
    },
    doParentZoomRefresh() {
      const { coordinates: t, lastZoom: e, zoom: n } = this.canvasState, o = t.x / e * n, i = t.y / e * n;
      this.canvasState.lastZoom = n, this.canvasStyle = {
        transform: `translate(${o}px, ${i}px) scale(${n})`
      };
    },
    doSetTempConnectionPath() {
      if (this.connectorState.toCoordinates && this.connectorState.fromRect) {
        const { x: t, y: e } = this.connectorState.toCoordinates, {
          height: n,
          width: o,
          x: i,
          y: r
        } = this.connectorState.fromRect, { zoom: s } = this.canvasState, a = this.getCanvasRect(), c = (a == null ? void 0 : a.height) || 0, l = (a == null ? void 0 : a.width) || 0, h = l / (l * s) || 0, u = c / (c * s) || 0, g = (a == null ? void 0 : a.x) || 0, d = (a == null ? void 0 : a.y) || 0, S = o / 2 + (i - g) * h, y = n / 2 + (r - d) * u, $ = t * (l / (l * s)) - g * (l / (l * s)), C = e * (c / (c * s)) - d * (c / (c * s));
        this.connectorState.pathObject = {
          from: {
            x: S,
            y
          },
          to: {
            x: $,
            y: C
          }
        }, this.connectorState.path = `M ${S} ${y} L ${$} ${C}`;
      } else
        this.connectorState.pathObject = void 0, this.connectorState.path = void 0;
    },
    doUpdateItemMovedConnections(t) {
      this.localList.forEach(
        (e, n) => {
          [...e.connections || []].some(
            (o) => o.from.item === t || o.to.item === t
          ) && [...e.connections || []].forEach(
            (o, i) => {
              if (o.from.item === t || o.to.item === t) {
                const r = document.getElementById(
                  `org-${this.$.uid}-item-${n}-connection-${i}`
                ), s = r == null ? void 0 : r.getElementsByTagName(
                  "path"
                ), a = String(
                  this.$.uid
                ), c = this.getCanvasRect(), l = c.height || 0, h = c.width || 0, u = h / (h * this.canvasState.zoom) || 0, g = l / (l * this.canvasState.zoom) || 0, d = me(
                  t,
                  o,
                  s,
                  a,
                  {
                    canvasHeight: g,
                    canvasWidth: u,
                    x: c.x,
                    y: c.y
                  }
                );
                d && s && s[0].setAttributeNS(
                  null,
                  "d",
                  d
                );
              }
            }
          );
        }
      );
    },
    doUpdatePointMovedConnection(t, e, n) {
      const o = document.getElementById(
        `org-${this.$.uid}-item-${n}-connection-${e}`
      ), i = o == null ? void 0 : o.getElementsByTagName("path"), r = ge(
        t,
        i
      );
      r && i && i[0].setAttributeNS(null, "d", r);
    },
    getCanvasRect() {
      return this.$refs["canvas-tree"] ? {
        ...this.$refs["canvas-tree"].getBoundingClientRect().toJSON()
      } : null;
    },
    getCoordinatesEnd(t) {
      return t.type === "touchend" ? {
        x: this.mouseState.mouse.x,
        y: this.mouseState.mouse.y
      } : {
        x: t.clientX,
        y: t.clientY
      };
    },
    getCoordinatesMove(t, e) {
      const n = e || 10, i = (() => t.type === "touchmove" || t.type === "touchstart" ? {
        x: t.touches[0].clientX,
        y: t.touches[0].clientY
      } : {
        x: t.clientX,
        y: t.clientY
      })();
      return e && e < 2 ? i : Math.abs(i.x - this.parentState.position.x) >= n || Math.abs(i.y - this.parentState.position.y) >= n ? {
        x: Math.round(i.x / n) * n,
        y: Math.round(i.y / n) * n
      } : this.parentState.position;
    },
    getOptionLine(t) {
      return `
					<div class="line-opt ${t.value}">
						<div></div>
					</div>
				`;
    },
    handleChangeItemPoint(t, e) {
      this.localList[e] = { ...t }, this.$nextTick(() => this.$emit("change", this.localList));
    },
    handleChangeLineType(t) {
      if (this.selectedConnection) {
        const e = this.selectedConnection.key.split("-connection-");
        this.selectedConnection = null;
        const n = Number(
          e[0].split("-item-")[1]
        ), o = Number(e[1]);
        if (this.localList[n]) {
          const i = [
            ...this.localList[n].connections || []
          ];
          i[o].type = t, this.localList[n].connections = [...i], this.$nextTick(() => {
            this.$emit("change", this.localList);
          });
        }
      }
    },
    handleClickItem(t, e) {
      this.$emit("clickItem", t, e);
    },
    handleConnectionDragged(t, e) {
      this.connectorState.from = t, this.connectorState.fromRect = { ...e.toJSON() }, this.selectedConnection = null;
    },
    handleItemChangePosition(t) {
      if (this.draggedItem) {
        const e = Number(
          this.draggedItem.key.split("-item-")[1]
        ), n = [
          ...this.localList
        ], o = {
          ...n[e].coordinates
        };
        (o.x !== t.x || o.y !== t.y) && (this.isItemMoved = !0, n[e] = {
          ...this.localList[e],
          coordinates: t
        }, this.localList = [...n], this.$nextTick(
          () => this.doUpdateItemMovedConnections(e)
        ));
      }
    },
    handleItemDragged(t) {
      this.draggedItem = { ...t }, this.selectedItem = { ...t }, this.mouseState.position = { ...t.coordinates }, this.parentState.position = { ...t.coordinates }, this.selectedConnection = null;
    },
    handleParentClick(t) {
      const e = this.getCoordinatesMove(t, 1), n = this.$refs["connection-options-wrapper"], o = t.target;
      (!this.selectedConnection || this.selectedConnection && (!n || n && !n.contains(o) && !n.isSameNode(o))) && (this.selectedConnection = null, this.parentState.isDrag = !0, this.mouseState.mouse = { ...e }, this.mouseState.position = { ...e }, this.mouseState.positionStart = { ...e }, this.selectedLineType = "solid", this.selectedItem = null);
    },
    handleParentClickOutside(t) {
      const e = t.target, n = this.$refs["organization-wrapper"];
      e && n && !n.contains(e) && !e.isSameNode(n) && (this.isItemMoved = !1, this.parentState.isDrag = !1, this.draggedItem = null, this.connectorState = {
        from: null,
        fromRect: null,
        path: void 0,
        toCoordinates: null
      }, this.pointState = {
        fromRect: null,
        target: null,
        toCoordinates: null
      }, this.selectedItem = null);
    },
    handleParentDragEnd(t) {
      const { x: e, y: n } = this.getCoordinatesEnd(t), { coordinates: o } = this.canvasState, i = o.x + -(this.mouseState.position.x - e), r = o.y + -(this.mouseState.position.y - n);
      if (this.parentState.isDrag)
        this.canvasState.coordinates = {
          x: i,
          y: r
        };
      else if (this.connectorState.from) {
        const s = t.target;
        if (s.id !== this.connectorState.from && s.classList.contains("io") && !this.isConnectionExist(
          this.connectorState.from,
          s.id
        )) {
          const c = this.connectorState.from.split("-io-")[0], l = Number(
            this.connectorState.from.split("-io-")[1]
          ), h = Number(
            c.split("-item-")[1]
          ), u = s.id.split("-io-")[0], g = Number(
            s.id.split("-io-")[1]
          ), d = Number(
            u.split("-item-")[1]
          );
          if (this.localList[h] && this.localList[d] && this.connectorState.fromRect) {
            const S = [
              ...this.localList
            ];
            S[h].connections = [
              ...S[h].connections || [],
              {
                from: {
                  io: l,
                  item: h
                },
                to: {
                  io: g,
                  item: d
                },
                type: "solid"
              }
            ], this.localList = [...S];
          }
        }
      } else if (this.draggedItem && !this.isItemMoved) {
        const { key: s } = this.draggedItem, a = Number(
          String(s).split("-item-")[1]
        );
        this.$emit(
          "clickItem",
          this.localList[a],
          a
        );
      }
      this.$nextTick(() => {
        (this.draggedItem || this.pointState.target || this.connectorState.from) && this.$nextTick(
          () => this.$emit("change", this.localList)
        ), this.isItemMoved = !1, this.parentState.isDrag = !1, this.draggedItem = null, this.connectorState = {
          from: null,
          fromRect: null,
          path: void 0,
          toCoordinates: null
        }, this.pointState = {
          fromRect: null,
          target: null,
          toCoordinates: null
        };
      });
    },
    async handleParentKeydown(t) {
      if (t.key === "Delete" || t.key === "Backspace") {
        if (this.selectedConnection) {
          t.preventDefault();
          const e = this.selectedConnection.key.split("-connection-");
          this.selectedConnection = null;
          const n = Number(
            e[0].split("-item-")[1]
          ), o = Number(
            e[1]
          );
          if (this.localList[n]) {
            const i = [
              ...this.localList[n].connections || []
            ];
            this.localList[n].connections = i.filter(
              (r, s) => s !== o
            ), this.$nextTick(() => {
              this.$emit("change", this.localList);
            });
          }
        } else if (this.selectedItem) {
          t.preventDefault();
          const e = Number(
            this.selectedItem.key.split("-item-")[1]
          ), o = [
            ...[
              ...this.localList
            ].filter(
              (i, r) => r !== e
            )
          ].map((i) => {
            if (i.connections) {
              const r = [
                ...i.connections
              ].filter(
                (s) => s.from.item !== e && s.to.item !== e
              ).map((s) => s.from.item > e || s.to.item > e ? {
                ...s,
                ...s.from.item > e && {
                  from: {
                    ...s.from,
                    item: s.from.item - 1
                  }
                },
                ...s.to.item > e && {
                  to: {
                    ...s.to,
                    item: s.to.item - 1
                  }
                }
              } : s);
              return {
                ...i,
                connections: r
              };
            }
            return i;
          });
          this.localList = [...o], this.$nextTick(() => {
            this.$emit("change", this.localList);
          });
        }
      }
    },
    handleParentPointerDown(t) {
      this.parentPointerState.events.push(t);
    },
    handleParentPointerMove(t) {
      this.parentPointerState.events = [
        ...this.parentPointerState.events
      ].map((e) => e.pointerId === t.pointerId ? t : e), this.$nextTick(() => {
        if (this.parentPointerState.events.length === 2) {
          const e = Math.abs(
            this.parentPointerState.events[0].clientX - this.parentPointerState.events[1].clientX
          );
          this.parentPointerState.prevDiff > 100 && e > this.parentPointerState.prevDiff ? this.doParentZoom(0.1) : this.parentPointerState.prevDiff > 100 && e < this.parentPointerState.prevDiff && this.doParentZoom(-0.1), this.parentPointerState.prevDiff = e;
        }
      });
    },
    handleParentPointerUp(t) {
      this.parentPointerState.events = [
        ...this.parentPointerState.events
      ].filter((e) => e.pointerId !== t.pointerId), this.$nextTick(() => {
        this.parentPointerState.events.length < 2 && (this.parentPointerState.prevDiff = -1);
      });
    },
    handleParentPosition(t) {
      const e = this.pointState.target ? 5 : this.connectorState.from ? 1 : 10, { x: n, y: o } = this.getCoordinatesMove(
        t,
        e
      ), { x: i, y: r } = this.parentState.position, { coordinates: s, zoom: a } = this.canvasState, c = this.getCanvasRect();
      if (this.parentState.isDrag) {
        const l = s.x + -(this.mouseState.position.x - n), h = s.y + -(this.mouseState.position.y - o);
        this.canvasStyle = {
          transform: `translate(${l}px, ${h}px) scale(${a})`
        };
      } else if (this.draggedItem) {
        t.preventDefault();
        const { x: l, y: h } = this.mouseState.position, u = (l - n) * ((c == null ? void 0 : c.width) || 0) / (((c == null ? void 0 : c.width) || 0) * a), g = (h - o) * ((c == null ? void 0 : c.height) || 0) / (((c == null ? void 0 : c.height) || 0) * a);
        this.handleItemChangePosition({
          x: Math.round(
            (this.draggedItem.elem.offsetLeft - u) / 10
          ) * 10,
          y: Math.round(
            (this.draggedItem.elem.offsetTop - g) / 10
          ) * 10
        }), this.$nextTick(() => this.mouseState.position = { x: n, y: o });
      } else if (this.connectorState.from)
        this.connectorState.toCoordinates = {
          x: n,
          y: o
        }, this.$nextTick(() => this.doSetTempConnectionPath());
      else if (this.pointState.target && this.canvasState.elem && (n !== i || o !== r)) {
        const {
          height: l,
          width: h,
          x: u,
          y: g
        } = this.canvasState.elem.getBoundingClientRect().toJSON(), d = n * (h / (h * a)) - u * (h / (h * a)), S = o * (l / (l * a)) - g * (l / (l * a)), { target: y } = this.pointState, $ = [
          ...this.localList[y.item].connections || []
        ], C = [
          ...$[y.connection].points || []
        ];
        C[y.point] = {
          x: Math.round(d / 5) * 5,
          y: Math.round(S / 5) * 5
        }, this.doUpdatePointMovedConnection(
          [...C],
          y.connection,
          y.item
        ), $[y.connection] = {
          ...$[y.connection],
          points: [...C]
        }, this.localList[y.item].connections = [
          ...$
        ];
      }
      this.parentState.position = {
        x: n,
        y: o
      }, t.type === "touchmove" && (this.mouseState.mouse = {
        x: n,
        y: o
      });
    },
    handleParentZoom(t) {
      t.ctrlKey && (t.preventDefault(), t.deltaY > 0 && this.canvasState.zoom > 0.5 ? this.doParentZoom(-0.1) : this.canvasState.zoom < 1.6 && this.doParentZoom(0.1));
    },
    handlePointDragged(t, e) {
      this.pointState.target = { ...t }, this.pointState.fromRect = { ...e.toJSON() };
    },
    handleSelectConnection(t) {
      this.selectedConnection = { ...t }, this.selectedLineType = t.type || "solid";
    },
    isConnectionExist(t, e) {
      return [...this.localList].flatMap(
        (o) => o.connections ? [...o.connections] : []
      ).some((o) => {
        const i = `org-${this.$.uid}-item-${o.from.item}-io-${o.from.io}`, r = `org-${this.$.uid}-item-${o.to.item}-io-${o.to.io}`;
        return t === i && e === r || t === r && e === i;
      });
    },
    isItemDragged(t) {
      var e;
      return ((e = this.draggedItem) == null ? void 0 : e.key) === t && this.isItemMoved;
    },
    isItemSelected(t) {
      var e;
      return ((e = this.selectedItem) == null ? void 0 : e.key) === t;
    }
  },
  watch: {
    list: {
      deep: !0,
      handler(t) {
        this.localList = [...t];
      },
      immediate: !0
    }
  },
  mounted() {
    this.$refs["canvas-tree"] && (this.canvasState.elem = this.$refs["canvas-tree"]), document.addEventListener("keydown", this.handleParentKeydown), document.addEventListener(
      "click",
      (t) => this.handleParentClickOutside(t)
    );
  },
  unmounted() {
    this.canvasState.elem = null, document.removeEventListener("keydown", this.handleParentKeydown), document.removeEventListener(
      "click",
      (t) => this.handleParentClickOutside(t)
    );
  },
  expose: ["doExport"]
});
const Re = ["id"], Me = {
  key: 0,
  class: "connection connecting",
  xmlns: "http://www.w3.org/2000/svg"
}, De = ["d"], Oe = {
  key: 0,
  class: "connection-options-wrapper",
  ref: "connection-options-wrapper"
}, Xe = ["id"];
function Ae(t, e, n, o, i, r) {
  const s = K("sb-org-tree-item"), a = K("sb-dropdown");
  return m(), f("div", gt(ft({ ...t.$attrs })), [
    T("div", {
      class: X([{
        connecting: t.connectorState.from,
        dragging: t.parentState.isDrag
      }, "organization-wrapper"]),
      id: `org-${t.$.uid}`,
      ref: "organization-wrapper",
      onMousedown: e[1] || (e[1] = p((...c) => t.handleParentClick && t.handleParentClick(...c), ["stop"])),
      onMousemove: e[2] || (e[2] = p((...c) => t.handleParentPosition && t.handleParentPosition(...c), ["stop"])),
      onMouseup: e[3] || (e[3] = p((...c) => t.handleParentDragEnd && t.handleParentDragEnd(...c), ["stop"])),
      onPointercancel: e[4] || (e[4] = (...c) => t.handleParentPointerUp && t.handleParentPointerUp(...c)),
      onPointerdown: e[5] || (e[5] = (...c) => t.handleParentPointerDown && t.handleParentPointerDown(...c)),
      onPointerleave: e[6] || (e[6] = (...c) => t.handleParentPointerUp && t.handleParentPointerUp(...c)),
      onPointermove: e[7] || (e[7] = (...c) => t.handleParentPointerMove && t.handleParentPointerMove(...c)),
      onPointerout: e[8] || (e[8] = (...c) => t.handleParentPointerUp && t.handleParentPointerUp(...c)),
      onPointerup: e[9] || (e[9] = (...c) => t.handleParentPointerUp && t.handleParentPointerUp(...c)),
      onTouchend: e[10] || (e[10] = p((...c) => t.handleParentDragEnd && t.handleParentDragEnd(...c), ["stop"])),
      onTouchmove: e[11] || (e[11] = p((...c) => t.handleParentPosition && t.handleParentPosition(...c), ["stop"])),
      onTouchstart: e[12] || (e[12] = p((...c) => t.handleParentClick && t.handleParentClick(...c), ["stop"])),
      onWheel: e[13] || (e[13] = p((...c) => t.handleParentZoom && t.handleParentZoom(...c), ["stop"]))
    }, [
      T("div", {
        class: X(["canvas", {
          "connection-selected": t.selectedConnection
        }]),
        ref: "canvas-tree",
        style: A(t.canvasStyle)
      }, [
        t.canvasState.elem ? (m(), f(E, { key: 0 }, [
          (m(!0), f(E, null, D(t.localList, (c, l) => (m(), G(s, pt({
            "canvas-state": t.canvasState,
            "connector-state": t.connectorState,
            "is-dragged": t.isItemDragged(`org-${t.$.uid}-item-${l}`),
            "is-selected": t.isItemSelected(`org-${t.$.uid}-item-${l}`),
            key: `org-${t.$.uid}-item-${l}`,
            "selected-connection": t.selectedConnection
          }, {
            isEditable: t.isEditable,
            item: c
          }, {
            onChangePoint: t.handleChangeItemPoint,
            onClickItem: t.handleClickItem,
            onDragConnection: t.handleConnectionDragged,
            onDragItem: t.handleItemDragged,
            onDragPoint: t.handlePointDragged,
            onSelectConnection: t.handleSelectConnection
          }), null, 16, ["canvas-state", "connector-state", "is-dragged", "is-selected", "selected-connection", "onChangePoint", "onClickItem", "onDragConnection", "onDragItem", "onDragPoint", "onSelectConnection"]))), 128)),
          t.connectorState.from ? (m(), f("svg", Me, [
            T("path", {
              d: t.connectorState.path
            }, null, 8, De)
          ])) : O("", !0)
        ], 64)) : O("", !0)
      ], 6),
      t.selectedConnection ? (m(), f("div", Oe, [
        yt(a, {
          flat: "",
          "opt-value": "value",
          type: "flat",
          modelValue: t.selectedLineType,
          "onUpdate:modelValue": e[0] || (e[0] = (c) => t.selectedLineType = c),
          list: t.lineType,
          "opt-label": t.getOptionLine,
          onChange: t.handleChangeLineType
        }, null, 8, ["modelValue", "list", "opt-label", "onChange"])
      ], 512)) : O("", !0)
    ], 42, Re),
    (m(), G(St, { to: "body" }, [
      t.isExporting ? (m(), f("div", {
        key: 0,
        class: "export-area-org-chart",
        id: `org-${t.$.uid}-export-area`,
        style: A(t.exportAreaStyle)
      }, null, 12, Xe)) : O("", !0)
    ]))
  ], 16);
}
const je = /* @__PURE__ */ rt(Le, [["render", Ae]]);
export {
  je as default
};
